/**
 * Some keyboard/mouse/joystick input functions

 * Copyright (C) 2003  Shawn Betts
 * Copyright (C) 2003  Andrew McCall
 * Copyright (C) 2003  Andrew Reading
 * Portions Copyright (C) Seth A. Robinson, 1997-2003

 * This file is part of GNU FreeDink

 * GNU FreeDink is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.

 * GNU FreeDink is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with program; see the file COPYING. If not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.

 * $Header: /cvsroot/dink/dink/src/input.cpp,v 1.2 2003/11/14 06:04:29 Beuc Exp $
 */

#include "dink.h"

BOOL
keypressed (void)
{
  for (int x = 0; x < 256; x++)

    {
      if (GetKeyboard (SDLKey (x)))
	{
	  return (TRUE);
	}
    }
  return (FALSE);
}


void
check_joystick (void)
{

//UNREFERENCED   int total;

  for (int e2 = 1; e2 <= 10; e2++)
    {

      sjoy.joybit[e2] = FALSE;

    }

  sjoy.right = FALSE;
  sjoy.left = FALSE;
  sjoy.up = FALSE;
  sjoy.down = FALSE;

  sjoy.rightd = FALSE;
  sjoy.leftd = FALSE;
  sjoy.upd = FALSE;
  sjoy.downd = FALSE;


//UNREFERENCED pass:

  // 17
  if (GetKeyboard (SDLK_LCTRL))
    sjoy.joybit[1] = TRUE;
  if (GetKeyboard (SDLK_SPACE))
    sjoy.joybit[2] = TRUE;
  if (GetKeyboard (SDLK_LSHIFT))
    sjoy.joybit[3] = TRUE;
  if (GetKeyboard (SDLK_RETURN))
    sjoy.joybit[4] = TRUE;
  if (GetKeyboard (SDLK_ESCAPE))
    sjoy.joybit[5] = TRUE;

  // 54, 55
  if (GetKeyboard (SDLK_6))
    sjoy.joybit[6] = TRUE;
  if (GetKeyboard (SDLK_7))
    sjoy.joybit[7] = TRUE;

  for (int x5 = 1; x5 <= 10; x5++)
    sjoy.button[x5] = FALSE;

  for (int x = 1; x <= 10; x++)

    {
      if (sjoy.joybit[x])

	{

	  if (sjoy.letgo[x] == TRUE)

	    {

	      sjoy.button[x] = TRUE;
	      sjoy.letgo[x] = FALSE;

	    }



	}

    }


  if (GetKeyboard (SDLK_RIGHT))
    sjoy.right = TRUE;
  if (GetKeyboard (SDLK_LEFT))
    sjoy.left = TRUE;
  if (GetKeyboard (SDLK_DOWN))
    sjoy.down = TRUE;
  if (GetKeyboard (SDLK_UP))
    sjoy.up = TRUE;


  for (int x2 = 1; x2 <= 10; x2++)

    {

      if (sjoy.joybit[x2])
	sjoy.letgo[x2] = FALSE;
      else
	sjoy.letgo[x2] = TRUE;

    }


  if (sjoy.right)
    if (sjoy.rightold == TRUE)

      {

	sjoy.rightd = true;
	sjoy.rightold = false;

      }


  if (sjoy.right)
    sjoy.rightold = false;
  else
    sjoy.rightold = true;


  if (sjoy.left)
    if (sjoy.leftold == TRUE)

      {

	sjoy.leftd = true;
	sjoy.leftold = false;

      }



  if (sjoy.left)
    sjoy.leftold = false;
  else
    sjoy.leftold = true;
  if (sjoy.up)
    if (sjoy.upold == TRUE)

      {

	sjoy.upd = true;

	sjoy.upold = false;

      }

  if (sjoy.up)
    sjoy.upold = false;
  else
    sjoy.upold = true;
  if (sjoy.down)
    if (sjoy.downold == TRUE)

      {

	sjoy.downd = true;

	sjoy.downold = false;

      }

  if (sjoy.down)
    sjoy.downold = false;
  else
    sjoy.downold = true;

  if (wait.active)

    {

      //check for dirs

      if (sjoy.rightd)
	wait.button = 16;
      if (sjoy.leftd)
	wait.button = 14;
      if (sjoy.upd)
	wait.button = 18;
      if (sjoy.downd)
	wait.button = 12;

      sjoy.rightd = false;
      sjoy.downd = false;
      sjoy.upd = false;
      sjoy.leftd = false;

      //check buttons

      for (int ll = 1; ll <= 10; ll++)

	{

	  if (sjoy.button[ll])

	    {
	      //button was pressed
	      wait.button = ll;

	    }
	  sjoy.button[ll] = false;

	}

      if (wait.button != 0)

	{

	  *presult = wait.button;
	  wait.active = false;
	  run_script (wait.script);

	}
    }
}



BOOL
CheckJoyStickPresent (void)
{
  // first tests if a joystick driver is present
  // if TRUE it makes certain that a joystick is plugged in


  if (SDL_NumJoysticks () > 0)

    {
      jinfo = SDL_JoystickOpen (0);
      Msg (("Name: %s\n", SDL_JoystickName (0)));
      Msg (("Number of Axes: %s\n", SDL_JoystickNumAxes (jinfo)));
      Msg (("Number of Buttons: %s\n", SDL_JoystickNumButtons (jinfo)));
      Msg (("Number of Balls: %s\n", SDL_JoystickNumBalls (jinfo)));
      return TRUE;

    }

  return FALSE;

}


void
Scrawl_OnMouseInput (void)
{

  UpdateCursorPosition (mouse_status.x, mouse_status.y);
  mouse1 = mouse_status.button;

}


bool
getkey (int key)
{
  if (sjoy.realkey[key])
    return (true);
  else
    return (false);

}

int
GetKeyboard (int key)
{
  // returns 0 if the key has been depressed, else returns 1 and sets key to code recd.
//      return (GetAsyncKeyState (key));
  Uint8 *keystate = SDL_GetKeyState (NULL);

  return keystate[key];
}


char
key_convert (int key)
{
  if (!getkey (16))
    key = tolower (key);

  if (key == 190)
    if (getkey (16))
      key = '>';
    else
      key = '.';
  if (key == 188)
    if (getkey (16))
      key = '<';
    else
      key = ',';

  if (key == 49)
    if (getkey (16))
      key = '!';
  if (key == 50)
    if (getkey (16))
      key = '@';
  if (key == 51)
    if (getkey (16))
      key = '#';
  if (key == 52)
    if (getkey (16))
      key = '$';
  if (key == 53)
    if (getkey (16))
      key = '%';
  if (key == 54)
    if (getkey (16))
      key = '^';
  if (key == 55)
    if (getkey (16))
      key = '&';
  if (key == 56)
    if (getkey (16))
      key = '*';
  if (key == 57)
    if (getkey (16))
      key = '(';
  if (key == 48)
    if (getkey (16))
      key = ')';

  if (key == 189)
    if (getkey (16))
      key = '_';
    else
      key = '-';
  if (key == 187)
    if (getkey (16))
      key = '+';
    else
      key = '=';
  if (key == 186)
    if (getkey (16))
      key = ':';
    else
      key = ';';
  if (key == 222)
    if (getkey (16))
      key = '\"';
    else
      key = '\'';
  if (key == 191)
    if (getkey (16))
      key = '?';
    else
      key = '/';
  if (key == 220)
    if (getkey (16))
      key = '|';
    else
      key = '\\';


  return (key);

}

BOOL
init_mouse ()
{
  return true;
}
